/* global Components, Services, APP_STARTUP, APP_SHUTDOWN */
/* exported startup, shutdown, install, uninstall */

"use strict";

var
	app_name = "Viewhance",
	app_baseURI = "chrome://" + app_name.toLowerCase() + "/content/";

Components.utils["import"]("resource://gre/modules/Services.jsm");
// Components.utils["import"]("resource://gre/modules/devtools/Console.jsm");

function startup(data, reason) {
	var bgProcess = function(ev) {
		if (ev) {
			this.removeEventListener("load", bgProcess, false);
		}

		Components.classes["@mozilla.org/globalmessagemanager;1"]
							.getService(Components.interfaces.nsIMessageListenerManager)
							.loadFrameScript(app_baseURI + "frameScript.js", true);

		bgProcess = Services.appShell.hiddenDOMWindow.document;
		bgProcess = bgProcess.documentElement.appendChild(
			bgProcess.createElementNS("http://www.w3.org/1999/xhtml", "iframe")
		);
		bgProcess.setAttribute("id", app_name + "_bgProcess");
		bgProcess.setAttribute("src", app_baseURI + "background.html");
	};

	if (reason === APP_STARTUP) {
		let observer = {
			observe: function(subject, topic) {
				if (topic === "domwindowopened") {
					Services.ww.unregisterNotification(observer);
					subject.QueryInterface(Components.interfaces.nsIDOMWindow).addEventListener("load", bgProcess, false);
				}
			}
		};

		Services.ww.registerNotification(observer);
	}
	else {
		bgProcess();
	}
}

function shutdown(data, reason) {
	if (reason === APP_SHUTDOWN) {
		return;
	}

	// close extension tabs
	var enmrtr = Services.wm.getEnumerator("navigator:browser");

	while (enmrtr.hasMoreElements()) {
		let gBrowser = enmrtr.getNext().gBrowser, tabs = gBrowser.tabs, i = tabs.length;

		while (i--) {
			if (gBrowser.getBrowserForTab(tabs[i]).contentWindow.location.host === app_name.toLowerCase()) {
				gBrowser.removeTab(tabs[i]);
			}
		}
	}

	var bgFrame = Services.appShell.hiddenDOMWindow.document.getElementById(app_name + "_bgProcess");

	if (bgFrame) {
		Components.classes["@mozilla.org/globalmessagemanager;1"]
							.getService(Components.interfaces.nsIMessageListenerManager)
							.removeDelayedFrameScript(app_baseURI + "frameScript.js");
		bgFrame.parentNode.removeChild(bgFrame);
	}
}

function install() {
	// https://bugzil.la/719376
	Services.strings.flushBundles();
}

function uninstall() {}
